/*
 *	    ____  ____  _____   ____________
 *	   / __ / __ /  _/ | / /_  __/ __
 *	  / /_/ / /_/ // //  |/ / / / / /_/ /
 *	 / ____/ _, _// // /|  / / / / _, _/
 *	/_/   /_/ |_/___/_/ |_/ /_/ /_/ |_|
 *
 */

/*
 *	Formide App Project definition
 */

var fs 		= require('fs');
var	path	= require('path');

module.exports = {

	// static
	PROJECT_FILE: 'formide.project',
	PROJECT_DEFAULT:
	{
		"name": "",
		"app_id": "",
		"version": "1.0.0",
		"identifier": "",
    	"assets": false,
        "plugin": false,
        "config": false
	},

	// functions
	load: function()
	{
		this.file = this.PROJECT_FILE;

		if( fs.existsSync( this.file ) )
		{
			try
			{
				this.data = JSON.parse( fs.readFileSync( this.file ) );
				return this;
			}
			catch( e )
			{
				throw new Error( 'There was an error loading your '+this.PROJECT_FILE+' file: ' + e.message );
			}
		}
		else
		{
			throw new Error( 'The '+this.PROJECT_FILE+' file was not found. Run this command in the correct directory' );
		}
	},

	create: function( config )
	{
		var self = this;
		self.file = self.PROJECT_FILE;
		self.data = config;

		try
		{
			fs.mkdirSync( self.data.identifier );
			fs.writeFileSync( self.data.identifier + '/' + self.file, JSON.stringify( self.data, null, 4 ) );
			fs.mkdirSync( self.data.identifier + '/' + 'assets' );
			fs.mkdirSync( self.data.identifier + '/' + 'www' );
			return this;
		}
		catch( e )
		{
			throw new Error( 'There was an error saving your '+this.PROJECT_FILE+' file: ' + e.message );
		}
	},

	get: function( k )
	{
		if( !this.data )
		{
			return null;
		}

		if( k )
		{
			return this.data[k];
		}
		else
		{
			return this.data;
		}
	},

	set: function( k, v )
	{

	}
};